exec("Add-Ons/Brick_Large_Cubes/Server.cs");

//The maximum storage of a given material.
if($Pref::Server::Mat_Energy::GlobalStorage $= "")
	$Pref::Server::Mat_Energy::GlobalStorage = 10000;
if($Pref::Server::Mat_Energy::PlayerStorage $= "")
	$Pref::Server::Mat_Energy::PlayerStorage = 25;
if($Pref::Server::Mat_Metal::GlobalStorage $= "")
	$Pref::Server::Mat_Metal::GlobalStorage = 2000;
if($Pref::Server::Mat_Metal::PlayerStorage $= "")
	$Pref::Server::Mat_Metal::PlayerStorage = 5;

//Production of materials in units/hour.
if($Pref::Server::Mat_Energy::GlobalProduction $= "")
	$Pref::Server::Mat_Energy::GlobalProduction = 1250;//10000;
if($Pref::Server::Mat_Energy::PlayerProduction $= "")
	$Pref::Server::Mat_Energy::PlayerProduction = 1250;
if($Pref::Server::Mat_Metal::GlobalProduction $= "")
	$Pref::Server::Mat_Metal::GlobalProduction = 150;//1250;
if($Pref::Server::Mat_Metal::PlayerProduction $= "")
	$Pref::Server::Mat_Metal::PlayerProduction = 150;

//Max build rate of materials in units/second.
if($Pref::Server::Mat_Energy::MaxBuildRate $= "")
	$Pref::Server::Mat_Energy::MaxBuildRate = 5;
if($Pref::Server::Mat_Metal::MaxBuildRate $= "")
	$Pref::Server::Mat_Metal::MaxBuildRate = 1;
//if($Pref::Server::Mat_Energy::MaxPlayerRate $= "")
//	$Pref::Server::Mat_Energy::MaxPlayerRate = 5;
//if($Pref::Server::Mat_Energy::MaxGlobalRate $= "")
//	$Pref::Server::Mat_Energy::MaxGlobalRate = 1;
//if($Pref::Server::Mat_Metal::MaxPlayerRate $= "")
//	$Pref::Server::Mat_Metal::MaxPlayerRate = 1;
//if($Pref::Server::Mat_Metal::MaxGlobalRate $= "")
//	$Pref::Server::Mat_Metal::MaxGlobalRate = 0.2;

$Pref::Server::Mat_Energy::GlobalStorage = mClampF($Pref::Server::Mat_Energy::GlobalStorage, 0, 25000);
$Pref::Server::Mat_Energy::PlayerStorage = mClampF($Pref::Server::Mat_Energy::PlayerStorage, 10, 250);
$Pref::Server::Mat_Metal::GlobalStorage = mClampF($Pref::Server::Mat_Metal::GlobalStorage, 0, 10000);
$Pref::Server::Mat_Metal::PlayerStorage = mClampF($Pref::Server::Mat_Metal::PlayerStorage, 2, 100);

$Pref::Server::Mat_Energy::GlobalProduction = mClampF($Pref::Server::Mat_Energy::GlobalProduction, 0, 62500);
$Pref::Server::Mat_Energy::PlayerProduction = mClampF($Pref::Server::Mat_Energy::PlayerProduction, 100, 6250);
$Pref::Server::Mat_Metal::GlobalProduction = mClampF($Pref::Server::Mat_Metal::GlobalProduction, 0, 12500);
$Pref::Server::Mat_Metal::PlayerProduction = mClampF($Pref::Server::Mat_Metal::PlayerProduction, 10, 1250);

$Pref::Server::Mat_Energy::MaxBuildRate = mClampF($Pref::Server::Mat_Energy::MaxBuildRate, 0.5, 25);
$Pref::Server::Mat_Metal::MaxBuildRate = mClampF($Pref::Server::Mat_Metal::MaxBuildRate, 0.1, 5);
//$Pref::Server::Mat_Energy::MaxPlayerRate = mClampF($Pref::Server::Mat_Energy::MaxPlayerRate, 0.5, 25);
//$Pref::Server::Mat_Energy::MaxGlobalRate = mClampF($Pref::Server::Mat_Energy::MaxGlobalRate, 0.5, $Pref::Server::Mat_Energy::MaxPlayerRate);
//$Pref::Server::Mat_Metal::MaxPlayerRate = mClampF($Pref::Server::Mat_Metal::MaxPlayerRate, 0.1, 5);
//$Pref::Server::Mat_Metal::MaxGlobalRate = mClampF($Pref::Server::Mat_Metal::MaxGlobalRate, 0.1, $Pref::Server::Mat_Metal::MaxPlayerRate);

$XalCheats::InfMats = 0;
$XalCheats::FastLathe = 0;

$RealSpace::Animation = 0;


package EnergyBuilding
{
	function Armor::onTrigger(%data, %this, %trig, %tog)
	{
		if(%trig == 0 && %tog && !isObject(%this.getMountedImage(0)))
		{
			%eye = %this.getEyePoint(); %dir = %this.getEyeVector();
			%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%dir, 6)), $Typemasks::fxBrickAlwaysObjectType);
			%brick = firstWord(%ray); if(isObject(%brick) && isObject(%brick.EBuildShape) && !%brick.builders.isMember(%this))
			{
				if(%brick.cantLathe) return;
				if(%brick.cantHelpLathe)
				{
					%group = %brick.getGroup(); if(isObject(%brick.trueGroup)) %brick.trueGroup.add(%brick);
					if(getTrustLevel(%this, %brick) < $TrustLevel::You) %noLathing = 1;
					%group.add(%brick); if(%noLathing) return;
				}
				%brick.builders.add(%this); return;
			}
		}
		Parent::onTrigger(%data, %this, %trig, %tog);
	}
	
	function GameConnection::bottomPrint(%cl, %text, %time, %box, %over)
	{
		//if(!%over) %cl.lastBottomPrint = %text;
		Parent::bottomPrint(%cl, %text, %time, %box);
	}
	
	function GameConnection::createPlayer(%cl, %trans)
	{
		Parent::createPlayer(%cl, %trans);
		if(!isObject(%pl = %cl.player)) return;
		%pl.EBuild_MatLoop(getSimTime());
		for(%i=0;%i<%pl.getDatablock().maxTools;%i++)
			if(%pl.tool[%i].getName() $= "HammerItem")
			{
				%pl.tool[%i] = DenanolatherItem.getID();
				messageClient(%cl, 'MsgItemPickup', '', %i, DenanolatherItem.getID(), 1);
			}
	}
	
	function GameConnection::onClientEnterGame(%cl)
	{
		Parent::onClientEnterGame(%cl);
		%cl.mat_Energy = $EBuild::Client_[%cl.bl_id@"::StoredEnergy"];
		%cl.mat_Metal = $EBuild::Client_[%cl.bl_id@"::StoredMetal"];
	}
	
	function GameConnection::onClientLeaveGame(%cl)
	{
		$EBuild::Client_[%cl.bl_id@"::StoredEnergy"] = %cl.mat_Energy;
		$EBuild::Client_[%cl.bl_id@"::StoredMetal"] = %cl.mat_Metal;
		export("$EBuild*", "config/server/EBuild.cs");
		Parent::onClientLeaveGame(%cl);
	}
	
	function servercmdPlantBrick(%cl)
	{
		if(!isObject(%pl = %cl.player) || !isObject(%temp = %pl.tempbrick))
			return Parent::servercmdPlantBrick(%cl);
		%data = %temp.getDatablock();
		%brick = Parent::servercmdPlantBrick(%cl);
		if(isObject(%brick))
		{
			if(!isObject(Brickgroup_EBuild))
				MainBrickgroup.add(new SimGroup(Brickgroup_EBuild) { bl_id = 50; name = "The world"; });
			%brick.trueGroup = %brick.getGroup(); Brickgroup_EBuild.add(%brick);
			%brick.schedule(50, "beginEBuilding", getSimTime(), %pl);
		}
		return %brick;
	}
	
	function onExit()
	{
		export("$EBuild*", "config/server/EBuild.cs");
		Parent::onExit();
	}
};
activatePackage("EnergyBuilding");

function FormatSeconds(%total)
{
	%total = (%total - (%seconds = %total % 60)) / 60;
	%total = (%total - (%minutes = %total % 60)) / 60;
	%total = (%total - (%hours = %total % 24)) / 24;
	if(%total + %hours + %minutes == 0) %timeStr = %seconds@" second"@(%seconds == 1 ? "" : "s");
	else if(%total + %hours == 0) %timeStr = %minutes@":"@PadLeft(%seconds, 0, 2);
	else if(%total == 0) %timeStr = %hours@":"@PadLeft(%minutes, 0, 2)@":"@PadLeft(%seconds, 0, 2);
	else %timeStr = %total@":"@PadLeft(%hours, 0, 2)@":"@PadLeft(%minutes, 0, 2)@":"@PadLeft(%seconds, 0, 2);
	return %timeStr;
}

function fxDtsBrick::beginDelathe(%brick, %cantLathe)
{
	if(!isObject(%brick)) return;
	%brick.cantHelpLathe = 1;
	%brick.cantLathe |= %cantLathe;
	if(isObject(%brick.EBuildShape))
	{ %brick.fastDelathing = 1; return; }
	if(!isObject(Brickgroup_EBuild))
		MainBrickgroup.add(new SimGroup(Brickgroup_EBuild) { bl_id = 50; name = "The world"; });
	%brick.trueGroup = %brick.getGroup();
	Brickgroup_EBuild.add(%brick);
	%data = %brick.getDatablock();
	if(%brick.angleID & 1)
	{
		%sizeX = %data.brickSizeY / 2;
		%sizeY = %data.brickSizeX / 2;
	}
	else
	{
		%sizeX = %data.brickSizeX / 2;
		%sizeY = %data.brickSizeY / 2;
	}
	%sizeZ = %data.brickSizeZ / 5;
	%brick.disappear(-1);
	if(!isObject(%brick.EBuildShape))
	{
		%shape = new StaticShape()
		{
			datablock = EBuildBrickShape;
			position = %brick.getPosition();
			scale = vectorScale(%sizeX SPC %sizeY SPC %sizeZ, 0.5);
		};
		%brick.EBuildShape = %shape;
		%shape.EBuildBrick = %brick;
	}
	else %shape = %brick.EBuildShape;
	if(!isObject(%brick.builers)) %brick.builders = new SimSet();
	%brick.req_Energy = %data.getSurfaceAreaInTU();
	%brick.req_Metal = %data.getVolumeInTU();
	%brick.completion = 1;
	%brick.fastDelathing = 1;
	%brick.nanoStart = getSimTime();
	%brick.EBuildLoop(getSimTime());
	%shape.EBuildLoop();
}

function fxDtsBrick::beginEBuilding(%brick, %start, %pl)
{
	if(!isObject(%brick)) return;
	if(!isObject(%pl)) { %brick.trueGroup.add(%brick); %brick.delete(); return; }
	%eye = %pl.getEyePoint();
	%dir = %pl.getEyeVector();
	%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%dir, 6)), $Typemasks::fxBrickAlwaysObjectType);
	if(firstWord(%ray) != %brick) { %brick.trueGroup.add(%brick); %brick.delete(); return; }
	%data = %brick.getDatablock();
	if(%brick.angleID & 1)
	{
		%sizeX = %data.brickSizeY / 2;
		%sizeY = %data.brickSizeX / 2;
	}
	else
	{
		%sizeX = %data.brickSizeX / 2;
		%sizeY = %data.brickSizeY / 2;
	}
	%sizeZ = %data.brickSizeZ / 5;
	%shape = new StaticShape()
	{
		datablock = EBuildBrickShape;
		position = %brick.getPosition();
		scale = vectorScale(%sizeX SPC %sizeY SPC %sizeZ, 0.5);
	};
	%brick.disappear(-1);
	%brick.EBuildShape = %shape;
	%shape.EBuildBrick = %brick;
	%brick.builders = new SimSet();
	%brick.builders.add(%pl);
	%brick.req_Energy = %data.getSurfaceAreaInTU();
	%brick.req_Metal = %data.getVolumeInTU();
	%brick.nanoStart = %start;
	%brick.EBuildLoop(%start);
	%shape.EBuildLoop();
}

function fxDtsBrick::EBuildLoop(%brick, %last)
{
	if(!isObject(%shape = %brick.EBuildShape) || !isObject(%set = %brick.builders))
	{
		if(isObject(%shape)) %shape.delete();
		if(isObject(%set)) %set.delete();
		%brick.trueGroup.add(%brick);
		%brick.delete(); return;
	}
	%time = vectorDist(%last, %now = getSimTime()) / 1000;
	%count = %set.getCount();
	for(%i=0;%i<%count;%i++)
	{
		%pl = %set.getObject(%i);
		%eye = %pl.getEyePoint();
		%dir = %pl.getEyeVector();
		%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%dir, 6)), $Typemasks::fxBrickAlwaysObjectType);
		if(firstWord(%ray) != %brick) %set.remove(%pl);
	}
	%data = %brick.getDatablock();
	%energyStorage = %brick.getDatablock().isEnergyStorage;
	if((%builders = %set.getCount()) != 0)
	{
		%brick.cantHelpLathe = 0;
		
		%energyTime = %brick.req_Energy / $Pref::Server::Mat_Energy::MaxBuildRate;
		%metalTime = %brick.req_Metal / $Pref::Server::Mat_Metal::MaxBuildRate;
		%buildTime = getMax(%energyTime, %metalTime);
		%energyRate = %brick.req_Energy / %buildTime;
		%metalRate = %brick.req_Metal / %buildTime;
		%maxEnergyGain = %energyRate * %time;
		%maxMetalGain = %metalRate * %time;
	
	//	%playerEnergyTime = %brick.req_Energy / $Pref::Server::Mat_Energy::MaxPlayerRate;
	//	%playerMetalTime = %brick.req_Metal / $Pref::Server::Mat_Metal::MaxPlayerRate;
	//	%playerBuildTime = getMax(%playerEnergyTime, %playerMetalTime);
	//	%playerEnergyRate = %brick.req_Energy / %playerBuildTime;
	//	%playerMetalRate = %brick.req_Metal / %playerBuildTime;
	//	%playerMaxEnergyGain = %playerEnergyRate * %time;
	//	%playerMaxMetalGain = %playerMetalRate * %time;
		
	//	%globalEnergyTime = %brick.req_Energy / $Pref::Server::Mat_Energy::MaxGlobalRate;
	//	%globalMetalTime = %brick.req_Metal / $Pref::Server::Mat_Metal::MaxGlobalRate;
	//	%globalBuildTime = getMax(%globalEnergyTime, %globalMetalTime);
	//	%globalEnergyRate = %brick.req_Energy / %globalBuildTime;
	//	%globalMetalRate = %brick.req_Metal / %globalBuildTime;
	//	%globalMaxEnergyGain = %globalEnergyRate * %time;
	//	%globalMaxMetalGain = %globalEnergyRate * %time;
		
		for(%i=0;%i<%builders;%i++)
		{
			%pl = %set.getObject(%i);
			if(!isObject(%cl = %pl.client)) continue;
			
			%energyGain = getMin(%energyRate * %time, %cl.mat_Energy + (%energyStorage ? 0 : $EBuild::Global::StoredEnergy));
			%metalGain = getMin(%metalRate * %time, %cl.mat_Metal + (%energyStorage ? 0 : $EBuild::Global::StoredMetal));
			%totalGain = getMin(%energyGain / %maxEnergyGain, %metalGain / %maxMetalGain);
			%energyGain = %maxEnergyGain * %totalGain;
			%metalGain = %maxMetalGain * %totalGain;
			if(%cl.mat_Energy >= %energyGain) %cl.mat_Energy -= %energyGain;
			else { $EBuild::Global::StoredEnergy -= (%energyGain - %cl.mat_Energy); %cl.mat_Energy = 0; }
			if(%cl.mat_Metal >= %metalGain) %cl.mat_Metal -= %metalGain;
			else { $EBuild::Global::StoredMetal -= (%metalGain - %cl.mat_Metal); %cl.mat_Metal = 0; }
			
			if($XalCheats::FastLathe && %cl.bl_id == getNumKeyID()) %totalGain = getMax(%totalGain * 5, %buildTime / 20);
			
			%brick.completion += %time * %totalGain / %buildTime;
		}
		if(%brick.completion >= 1 && !%energyStorage) %brick.completion = 1;
		for(%i=0;%i<%builders;%i++)
		{
			%pl = %set.getObject(%i); if(!isObject(%cl = %pl.client)) continue;
			%timeToFinish = FormatSeconds(mCeil((%buildTime/%builders) * (1 - %brick.completion)));
			%pl.client.centerPrint("<color:00FF00>Nanolathing "@%data.uiName@" ("@mFloatLength(%brick.completion*100,1)@"%)...<br>"
				@"\c6"@(%builders>1?(%builders-1)@" other player"@(%builders==2?"":"s")@" assisting.":"")@"<br>"
				@(%energyStorage?"\c6Energy storage block":(%buildTime >= 20?"\c6Est. Time to Completion: "@%timeToFinish:"")), 3);
		}
		if($RealSpace::Animation)
		{
			if(%brick.angleID % 2)
			{
				%sizeY = %data.brickSizeX / 4;
				%sizeX = %data.brickSizeY / 4;
			}
			else
			{
				%sizeX = %data.brickSizeX / 4;
				%sizeY = %data.brickSizeY / 4;
			}
			%sizeZ = %data.brickSizeZ / 10;
			if(vectorDist(%shape.getPosition(), %brick.getPosition()) > 0.025)
				%shape.setTransform(%brick.getPosition()@" 1 0 0 0");
			%scalar = mPow(%brick.completion, 1 / 3);   //Linear-Cube Law
			%shape.setScale((%sizeX * %scalar) SPC (%sizeY * %scalar) SPC (%sizeZ * %scalar));
		}
		else
		{
			%shiftZ = %data.brickSizeZ / 10;
			if(%shiftZ*%brick.completion < 0.05)
			{
				%shape.setTransform(vectorSub(%brick.getPosition(), "0 0 "@%shiftZ*(1-%brick.completion*2)+0.05)@" 1 0 0 0");
				%shape.setScale(getWords(%shape.getScale(), 0, 1)@" 0.05");
			}
			else
			{
				%shape.setTransform(vectorSub(%brick.getPosition(), "0 0 "@%shiftZ*(1-%brick.completion))@" 1 0 0 0");
				%shape.setScale(getWords(%shape.getScale(), 0, 1) SPC %shiftZ*%brick.completion);
			}
		}
		//%currTime = $Sim::Time;
		//if((%dotPos = strPos(%currTime, ".")) == -1)
		//	%currTime = getSubStr(%currTime, strLen(%currTime) - 1, 1);
		//else	%currTime = getSubStr(%currTime, %dotPos - 1, strLen(%currTime) - (%dotPos - 1));
		//%green = mSin(%currTime / $PI / 10) * 0.25 + 0.5;
		%green = mSin(vectorDist(%brick.nanoStart, %now) / 200) * 0.25 + 0.5;
		%shape.setNodeColor("ALL", "0 "@%green@" 0 1");
		if(%brick.completion >= 1 && !%energyStorage)
		{
			%brick.trueGroup.add(%brick);
			%brick.disappear(0);
			%shape.delete();
			return;
		}
	}
	if(%builders == 0 || %energyStorage)
	{
		%undo = getMin(%brick.completion, %time / (%brick.fastDelathing ? 10 : 150));
		$EBuild::Global::StoredEnergy += %brick.req_Energy * %undo;
		$EBuild::Global::StoredMetal += %brick.req_Metal * %undo;
		%brick.completion -= %undo;
		if($RealSpace::Animation)
		{
			if(%brick.angleID % 2)
			{
				%sizeY = %data.brickSizeX / 4;
				%sizeX = %data.brickSizeY / 4;
			}
			else
			{
				%sizeX = %data.brickSizeX / 4;
				%sizeY = %data.brickSizeY / 4;
			}
			%sizeZ = %data.brickSizeZ / 10;
			if(vectorDist(%shape.getPosition(), %brick.getPosition()) > 0.025)
				%shape.setTransform(%brick.getPosition()@" 1 0 0 0");
			%scalar = mPow(%brick.completion, 1 / 3);   //Linear-Cube Law
			%shape.setScale((%sizeX * %scalar) SPC (%sizeY * %scalar) SPC (%sizeZ * %scalar));
		}
		else
		{
			%shiftZ = %data.brickSizeZ / 10;
			if(%shiftZ*%brick.completion < 0.05)
			{
				%shape.setTransform(vectorSub(%brick.getPosition(), "0 0 "@%shiftZ*(1-%brick.completion*2)+0.05)@" 1 0 0 0");
				%shape.setScale(getWords(%shape.getScale(), 0, 1)@" 0.05");
			}
			else
			{
				%shape.setTransform(vectorSub(%brick.getPosition(), "0 0 "@%shiftZ*(1-%brick.completion))@" 1 0 0 0");
				%shape.setScale(getWords(%shape.getScale(), 0, 1) SPC %shiftZ*%brick.completion);
			}
		}
		//%currTime = $Sim::Time;
		//if((%dotPos = strPos(%currTime, ".")) == -1)
		//	%currTime = getSubStr(%currTime, strLen(%currTime) - 1, 1);
		//else	%currTime = getSubStr(%currTime, %dotPos - 1, strLen(%currTime) - (%dotPos - 1));
		//%green = mSin(%currTime / $PI / 10) * 0.25 + 0.5;
		%green = mSin(vectorDist(%brick.nanoStart, %now) / 200) * 0.25 + 0.5;
		%shape.setNodeColor("ALL", "0 "@%green@" 0 1");
		if(mFloatLength(%brick.completion, 5) <= 0)
		{
			%chainkillSet = new SimSet();
			for(%i=0;%i<%brick.getNumUpBricks();%i++)
				%chainkillSet.add(%brick.getUpBrick(%i));
			for(%i=0;%i<%brick.getNumDownBricks();%i++)
				%chainkillSet.add(%brick.getDownBrick(%i));
			%cantLathe = %brick.cantLathe;
			%brick.EBuildShape.delete();
			%brick.trueGroup.add(%brick);
			%brick.delete();
			%chainkillCount = %chainkillSet.getCount();
			for(%i=0;%i<%chainkillCount;%i++)
				if(!(%brick = %chainkillSet.getObject(%i)).hasPathToGround())
					%brick.beginDelathe(%cantLathe);
			return;
		}
	}
	%brick.EBuildLoop = %brick.schedule(16, "EBuildLoop", %now);
}

//Returns the surface area of a brick datablock in TU?.
function fxDtsBrickData::getSurfaceAreaInTU(%data)
{
	%sizeX = %data.brickSizeX;
	%sizeY = %data.brickSizeY;
	%sizeZ = %data.brickSizeZ;
	return ((%sizeX * %sizeY) + (%sizeX * %sizeZ) + (%sizeY * %sizeZ)) / 4;
}

//Returns the volume of a brick datablock in TU?.
function fxDtsBrickData::getVolumeInTU(%data)
{
	%sizeX = %data.brickSizeX;
	%sizeY = %data.brickSizeY;
	%sizeZ = %data.brickSizeZ;
	return (%sizeX * %sizeY * %sizeZ) / 20;
}

function PadLeft(%str, %pattern, %len)
{
	if(strLen(%pattern) == 0) return;
	while(strLen(%str) < %len)
		%str = %pattern @ %str;
	return %str;
}

function PadRight(%str, %pattern, %len)
{
	if(strLen(%pattern) == 0) return;
	while(strLen(%str) < %len)
		%str = %str @ %pattern;
	return %str;
}

function Player::EBuild_MatLoop(%pl, %last)
{
	if(!isObject(%pl) || !isObject(%cl = %pl.client) || %pl.getState() $= "DEAD") return;
	%time = vectorDist(%last, %now = getSimTime()) / 1000;
	%cl.mat_Energy += $Pref::Server::Mat_Energy::PlayerProduction * (%time / 3600);
	%cl.mat_Metal += $Pref::Server::Mat_Metal::PlayerProduction * (%time / 3600);
	%cl.mat_Energy = mClampF(%cl.mat_Energy, 0, $Pref::Server::Mat_Energy::PlayerStorage);
	%cl.mat_Metal = mClampF(%cl.mat_Metal, 0, $Pref::Server::Mat_Metal::PlayerStorage);
	if($XalCheats::InfMats && %cl.bl_id == getNumKeyID())
	{
		%cl.mat_Energy = $Pref::Server::Mat_Energy::PlayerStorage;
		%cl.mat_Metal = $Pref::Server::Mat_Metal::PlayerStorage;
	}
	%text = "<color:C0C0C0>Metal\c6: "@mFloatLength(%cl.mat_Metal, 1)@"   <color:FFC000>Energy\c6: "@mFloatLength(%cl.mat_Energy, 1);
	if(%cl.lastEBuildPrint !$= %text)
	{
		%cl.bottomPrint(%text, -1, 1);
		%cl.lastEBuildPrint = %text;
	}
	%pl.EBuild_MatLoop = %pl.schedule(16, "EBuild_MatLoop", %now);
}

function servercmdGlobalStores(%cl)
{
	%cl.chatMessage("<color:C0C0C0>Stored Metal\c6: "@mFloatLength($EBuild::Global::StoredMetal, 1));
	%cl.chatMessage("<color:FFC000>Stored Energy\c6: "@mFloatLength($EBuild::Global::StoredEnergy, 1));
}

function StaticShape::EBuildLoop(%shape)
{
	if(!isObject(%brick = %shape.EBuildBrick) || %brick.isDead())
	{ %shape.delete(); return; }
	%shape.schedule(16, "EBuildLoop");
}

function EBuild_GlobalMatLoop(%last, %sum)
{
	%time = vectorDist(%last, %now = getSimTime()) / 1000;
	%sum += %time; %seconds = mFloor(%sum); %sum -= %seconds;
	$EBuild::Global::StoredEnergy += $Pref::Server::Mat_Energy::GlobalProduction * (%seconds / 3600);
	$EBuild::Global::StoredMetal += $Pref::Server::Mat_Metal::GlobalProduction * (%seconds / 3600);
	$EBuild::Global::StoredEnergy = mClampF($EBuild::Global::StoredEnergy, 0, $Pref::Server::Mat_Energy::GlobalStorage);
	$EBuild::Global::StoredMetal = mClampF($EBuild::Global::StoredMetal, 0, $Pref::Server::Mat_Metal::GlobalStorage);
	$EBuild_GlobalMatLoop = schedule(16, 0, "EBuild_GlobalMatLoop", %now, %sum);
}
EBuild_GlobalMatLoop(getSimTime());

datablock fxDtsBrickData(brickGlobalStorageCubeData : brick8xCubeData)
{
	category = "Special";
	subcategory = "Interactive";
	uiName = "Global Storage";
	isEnergyStorage = 1;
};

datablock StaticShapeData(EBuildBrickShape)
{ shapefile = "Add-Ons/Server_EnergyBuilding/Cube.dts"; };

datablock ItemData(DenanolatherItem)
{
	doColorShift = 1;
	colorShiftColor = "0 0.75 0 1";
	image = DenanolatherImage;
	uiName = "Denanolather";
};

datablock ShapeBaseImageData(DenanolatherImage : BrickImage)
{
	colorShiftColor = "0 0.75 0 1";
	item = DenanolatherItem;
};

function DenanolatherImage::onFire(%img, %obj, %slot)
{
	%eye = %obj.getEyePoint();
	%dir = %obj.getEyeVector();
	%mask = $Typemasks::fxBrickAlwaysObjectType | $Typemasks::StaticShapeObjectType;
	%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%dir, 6)), %mask);
	%hit = firstWord(%ray);
	if((%hit.getType() & $Typemasks::StaticShapeObjectType) && isObject(%hit.EBuildBrick)) %hit = %hit.EBuildBrick;
	if(%hit.getClassName() !$= "fxDtsBrick") return;
	%group = %hit.getGroup(); if(isObject(%hit.trueGroup)) %hit.trueGroup.add(%hit);
	if(!%hit.willCauseChainKill() && getTrustLevel(%obj, %hit) >= $TrustLevel::Hammer)
	{
		if(getTrustLevel(%obj, %hit) >= $TrustLevel::You)
		{
			if(isObject(%set = %hit.builders))
				for(%i=%set.getCount()-1;%i>=0;%i--)
					%set.remove(%set.getObject(%i));
		}
		%hit.beginDelathe();
	}
	%group.add(%hit);
}

function servercmdMagicWand(%cl)
{
	if(!isObject(%pl = %cl.player)) return;
	if(!%cl.isAdmin && !%cl.isSuperAdmin) return;
	%pl.mountImage(AdminDenanolatherImage, 0);
	fixArmReady(%pl);
}

datablock ShapeBaseImageData(AdminDenanolatherImage : BrickImage)
{
	colorShiftColor = "0.75 0 0 1";
	item = DenanolatherItem;
};

function AdminDenanolatherImage::onFire(%img, %obj, %slot)
{
	%eye = %obj.getEyePoint();
	%dir = %obj.getEyeVector();
	%mask = $Typemasks::fxBrickAlwaysObjectType | $Typemasks::PlayerObjectType | $Typemasks::VehicleObjectType;
	%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%dir, 250)), %mask, %obj);
	%hit = firstWord(%ray);
	if(%hit.getType() & $Typemasks::fxBrickAlwaysObjectType)
	{
		if(isObject(%set = %hit.builders))
			for(%i=%set.getCount()-1;%i>=0;%i--)
				%set.remove(%set.getObject(%i));
		%hit.beginDelathe(1);
	}
	else if(%hit.getType() & $Typemasks::PlayerObjectType) %hit.kill();
	else if(%hit.getType() & $Typemasks::VehicleObjectType) %hit.damage(0, 0, 10000);
}

if(isFile("config/server/EBuild.cs"))
	exec("config/server/EBuild.cs");